////////////////////////////////////////////////////////////////////////////
//
// shash.h - hash table indexed by strings
//
////////////////////////////////////////////////////////////////////////////
#ifndef _SHASH_H_
#define _SHASH_H_

#include "hash.h"

extern Boolean StringCompare(const char*& a, const char*& b);
extern unsigned int HashString(const char*& s);

template <class D> class StringTable : public HashTableOwnData<const char*, D> {
 public:
  StringTable(unsigned int size = 0, D dummy_data = 0)
#ifdef __GNUC__
    : HashTableOwnData<const char*, D>(StringCompare, HashString,
#else
    : HashTableOwnData<const char*, D>((Boolean (*)(const char*const&, const char*const&))StringCompare,
				       (unsigned int (*)(const char* const&))HashString,
#endif
				       size, (const char*)0, dummy_data) { }
};

#endif
