////////////////////////////////////////////////////////////////////////////
//
// misc.h - miscellaneous definitions and useful functions
//
////////////////////////////////////////////////////////////////////////////
#ifndef _MISC_H_
#define _MISC_H_

#include <assert.h>
#include "perc.h"
//#include "new.h"

class istream;
class ostream;
class stream;

// boolean type
enum Boolean { False = 0, True = 1 };

// where indicator for list insertion
enum Where { InsertBefore, InsertAfter };

// print a boolean
extern ostream& operator<<(ostream&, Boolean);

// convert an integer to a boolean value
#define MakeBoolean(a)  ((a) ? True : False)

// assert with a string message
#define s_assert(s, a) assert(s && a)

// typed swap
#define tswap(t, a, b) { t tmp = (a); a = (b); b = tmp; }

#ifndef max
#define max(a, b)   ((a) < (b) ? (b) : (a))
#endif

#ifndef min
#define min(a, b)   ((a) > (b) ? (b) : (a))
#endif

// strdup that uses new
extern char* Strdup(char* src);

// not found indicator
static const unsigned int NotFound = (unsigned int)-1;

// clear and copy memory chunks
extern void* MemClear(void*, unsigned int);
extern void* MemCopy(void* from, void* to, unsigned int);

#ifdef __GNUC__
extern "C" int gettimeofday(struct timeval*, struct timezone*);
#endif

#endif
