////////////////////////////////////////////////////////////////////////////
//
// new.h - allow overload of new operator (for tracking memory leaks)
//
////////////////////////////////////////////////////////////////////////////
#ifndef _NEW_H_
#define _NEW_H_

#include <malloc.h>
#include <sys/types.h>
#include <new.h>

#ifdef TRACE_NEW

enum ReportType { NoSort, ByFile, BySize };

#ifndef _TRACE_DEF_
#define malloc(s) new char[s]
#define calloc(n, s) new char[(s)*(n)]
#define realloc(a, s) renew(a, s, __FILE__, __LINE__)
#define free(a) delete a
#define new new(__FILE__, __LINE__)
#endif

extern void* operator new(size_t, const char*, unsigned int);
extern void* operator new[](size_t, const char*, unsigned int);
extern void operator delete(void*);

#elif defined(OVERLOAD_NEW)

extern void* operator new(size_t, void* = 0);
extern void* operator new[](size_t, void* = 0);
extern void operator delete(void*);

#endif

#endif

