#include <stream.h>
#include "perc.h"

PercCounter::operator float() const
{
  return (100.0 * _curr) / _max;
}

void PercCounter::operator++(int)
{
  operator+=(1);
}

void PercCounter::operator++()
{
  operator+=(1);
}

void PercCounter::operator+=(int adj)
{
  if((_curr += adj) > _max)
    _curr = _max;

  float p = (100.0 * _curr) / _max;
  if(p - _lastp >= _delta || _curr >= _max) {
#ifdef DEBUG
    if(_curr == _max) {
      cout << " 100%" << endl;
    } else {
      int oldp = cout.precision();
      cout.precision(2);
      cout << " " << p << "%" << flush;
      cout.precision(oldp);
    }
#endif
    _lastp = p;
  }
}

PercCounter::PercCounter(const char* msg, int max, float delta)
: _msg(msg), _max(max), _delta(delta), _lastp(0.0), _curr(0)
{
#ifdef DEBUG
  cout << msg << " -" << flush;
#endif
}
