////////////////////////////////////////////////////////////////////////////
//
// dx++.h - common useful dx functions
//
////////////////////////////////////////////////////////////////////////////
#ifndef _DX_PP_H_
#define _DX_PP_H_

extern "C" {
// redefine some names since I use the same ones
#define Object DXObject
#define Vector DXVector
#define Light DXLight
#define String DXString
#include <dx/dx.h>
#undef Vector
#undef Object
#undef Light
#undef String
};

#include "misc.h"

// scan values from array of DXObjects
extern Error dxscanf(DXObject* in, char* format, ...);

// print RGBColors
extern ostream& operator<<(ostream&, const RGBColor&);

// transpose array data
extern void Transpose(float*, int, int, int);

// convert a float to a DXObject
extern DXObject ToDX(float r);

#endif
