////////////////////////////////////////////////////////////////////////////
//
// dxcolor.h - C++ wrapper around DX color map (really a field)
//
////////////////////////////////////////////////////////////////////////////
#ifndef _COLORMAP_H_
#define _COLORMAP_H_

#include "dxiarray.h"

class Palette;

class ColorMap {
 public:
  operator DXObject() const;

  int Size() const { return _color.Size(); }  // size of the color map

  // index color data
  RGBColor& operator[](int i) const { return _color[i]; }

  // get ith color index
  float& Index(int i) const { return _index[i]; }

  ColorMap(int size);
  ColorMap(Field);
  ColorMap(const ColorMap&);
  ColorMap(const Palette&, float min = 0.0, float max = 1.0);
  ColorMap(Field, const Palette&, float min = 0.0, float max = 1.0);

  // destroy a color map
  ~ColorMap() { }
 private:
  Field _cmap;
  ColorArray _color;
  FloatArray _index;
};

#endif
