#include <stream.h>
#include "real.h"
#include "trig.h"
#include "timer.h"

#define test_trig(trig, num, min, max, delta)\
{\
  tid_t trig##_timer = timer_create(#trig);\
  timer_start(trig##_timer);\
  for(int n = 0; n < num; n++)\
   for(Real i = min; i < max; i += delta)\
     trig(i);\
  timer_stop(trig##_timer);\
  timer_print(trig##_timer);\
  cout << endl << flush;\
}


int main(int argc, char* argv[])
{
  TrigInit();

#if 0
  for(Real i = -4*M_PI; i < 4*M_PI; i += deg2rad(1.0)) {
    cout << "tanh(" << rad2deg(i) << ") = " << ftanh(i) << ", " << tanh(i) << endl;
    if(ftanh(i) >= 0.0)
      cout << "sqrt(tanh(" << rad2deg(i) << ")) = " << fsqrt1(i) << ", " << sqrt(i) << endl;
  }
#endif

  test_trig(fsin, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));
  test_trig(fcos, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));
  test_trig(ftanh, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));

  test_trig(sin, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));
  test_trig(cos, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));
  test_trig(tanh, 1000, -4*M_PI, 4*M_PI, deg2rad(1.0));

  return 0;
}
