////////////////////////////////////////////////////////////////////////////
//
// noise.h - generate perlin textures using recursive function
//           See Graphics Gems II and Foley & Van Dam for more
//           info (method from Graphics Gems II)
//
////////////////////////////////////////////////////////////////////////////
#ifndef _NOISE_H_
#define _NOISE_H_

#include "real.h"
#include "interp.h"

// perlin noise function at x, y, z
extern Real Noise(Real x, Real y, Real z);
extern Real FractalNoise(Real x, Real y, Real z);

// turbulence function at x, y, z with resolution of n
// computed using Noise(x, y, z)
extern Real Turbulence(Real x, Real y, Real z, int = 256);

#endif
