////////////////////////////////////////////////////////////////////////////
//
// fft.h - compute discrete FFTs and discrete inverse FFTs
//         (FFT function implemented from "Numerical Recipes In C")
//
////////////////////////////////////////////////////////////////////////////
#ifndef _FFT_H_
#define _FFT_H_

#include "complex.h"

// discrete 1d and 2d FFT
extern void FFT1d(MyComplex* data, int s);
extern void FFT2d(MyComplex* data, int w, int h);

// discrete 1d and 2d inverse FFT
extern void InvFFT1d(MyComplex* data, int s);
extern void InvFFT2d(MyComplex* data, int w, int h);

// compute FFT of arbitrary size and dimension
// dir controls inverse or forward FFT
// size must be an array of dim elements which contain
// the sizes of the data in each dimension
extern void FFT(MyComplex* data, int size[], int dim, Boolean dir);

#endif
