#include <stream.h>
#include "trig.h"
#include "point.h"

// create a spherical point from a rectangular point
SphericalPoint::SphericalPoint(const Point3d& p)
{
  radius = sqrt(p.x*p.x + p.y*p.y + p.z*p.z);
  phi = acos(p.z/radius);
  theta = acos(p.x/(radius*fsin(phi)));
}

// print a spherical point
ostream& SphericalPoint::Print(ostream& o, int) const
{
  o << "SphericalPoint(" << rad2deg(theta) << ", ";
  o << rad2deg(phi) << ", " << radius << ")";
  return o;
}

// print a spherical point
ostream& operator<<(ostream& os, const SphericalPoint& p)
{
  return p.Print(os);
}

// print a point
ostream& Point3d::Print(ostream& o, int) const
{
  o << "Point3d(" << x << ", " << y << ", " << z << ")";
  return o;
}

// print a point
ostream& operator<<(ostream& os, const Point3d& p)
{
  return p.Print(os);
}
