#include "palette.h"

// print contents of a palette
ostream& Palette::Print(ostream& os, int) const
{
  Object::Print(os);
  os << endl;
  for(int i = 0; i < Size(); i++)
    os << "Color[" << i << "] = " << _colors[i] << endl;
  return os;
}

// return integer index of given color in this palette
int Palette::operator[](const Color& c) const
{
  for(int i = 0; i < _size; i++)
    if(_colors[i] == c)
      return i;
  return -1;
}

void Palette::Scale(Real factor, int from, int to)
{
  if(to < 0) to = Size();
  for(int i = from; i < to; i++)
    _colors[i].Scale(factor);
}

void Palette::Brighten(Real factor, int from, int to)
{
  if(to < 0) to = Size();
  for(int i = from; i < to; i++)
    _colors[i].Brighten(factor);
}

void Palette::Darken(Real factor, int from, int to)
{
  if(to < 0) to = Size();
  for(int i = from; i < to; i++)
    _colors[i].Darken(factor);
}
